/**************************************************************************
**
** Copyright (C) Computer Science Department, Worcester Polytechnic Institute,
**                           All rights reserved.
**
** MediaTracker V2.0 Source Code
**
** AUTHOR: Mingzhe Li       Oct-2002
**
/**************************************************************************/

// MediaTrackerDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MediaTracker.h"
#include "MediaTrackerDlg.h"
#include <time.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMediaTrackerDlg dialog

CMediaTrackerDlg::CMediaTrackerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMediaTrackerDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMediaTrackerDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMediaTrackerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMediaTrackerDlg)
	DDX_Control(pDX, IDC_FPS, m_fps);
	DDX_Control(pDX, IDC_PLAYER, m_player);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMediaTrackerDlg, CDialog)
	//{{AFX_MSG_MAP(CMediaTrackerDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_OPEN, OnOpen)
	ON_BN_CLICKED(IDOK, OnPlay)
	ON_BN_CLICKED(IDC_STOP, OnStop)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_ABOUT, OnAbout)
	ON_BN_CLICKED(IDC_HELP, OnHelp)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMediaTrackerDlg message handlers

BOOL CMediaTrackerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	//default log name
	GetLogName(&pszFileName); //"myfile.dat"; maybe overwrite if you put command line argv.
	shutdown_flag = 0;
	timer_reset = 0;
	u_index = 0;
	url_count = 0;

	
	// Parse the command line parameters, if error, ignore all.
	if (CommandParser() == -1) 
		AfxMessageBox ("All command line parameters are ignored");

	// Create log file, the name maybe overwrited by command line parameters
	CreateLog();
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CMediaTrackerDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMediaTrackerDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMediaTrackerDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CMediaTrackerDlg::OnOpen() 
{
	COpenDialog open_url;
	CFileException fileException;
	
	if (open_url.DoModal() == IDOK){
		CWMPMedia addMedia;
		CWMPPlaylistArray addArray;
		plFile.open(open_url.m_url, ios::in);
		if (!plFile) {AfxMessageBox("Error");};
//		AfxMessageBox(next_url());
		next_url();
		m_player.SetUrl(next_Url);
		SetTimer(ID_TIMEOUT, 10000, NULL);
		
		
	
//		m_player.SetCurrentMedia(newList.GetItem(u_index));
//		newList = m_player.newPlaylist("list", open_url.m_url);
//		m_player.GetPlaylistCollection().importPlaylist(newList);
//		m_player.SetCurrentPlaylist(newList);
//		addMedia = m_player.GetMediaCollection().add(open_url.m_url);
//		addArray = m_player.GetPlaylistCollection().getByName(addMedia.GetName());
//		newList = addArray.Item(0);
//		m_player.SetCurrentPlaylist(newList);
//		CString c;
//		c.Format("Number is %d" , m_player.GetCurrentPlaylist().GetCount());
//		AfxMessageBox(c);
//		m_player.GetControls().play();
		
		//Set timer 500ms
//		SetTimer(ID_TIMER, 500, NULL);
	}	
}

void CMediaTrackerDlg::OnPlay() 
{
	SetTimer(ID_TIMER, 500, NULL);
	m_player.GetControls().play();	
}



void CMediaTrackerDlg::OnStop() 
{
	KillTimer(ID_TIMER);
	m_player.GetControls().stop();	
}

void CMediaTrackerDlg::OnCancel() 
{
	m_player.GetControls().stop();
	KillTimer(ID_TIMER);
	myFile.Close();
	plFile.close();
	CDialog::OnCancel();
}

void CMediaTrackerDlg::OnTimer(UINT nIDEvent) 
{
	double fps;
	long brate, bw, bufp, maxbw, encodefr, frskipped, recpkt, lostpkt, recoverpkt, quality;
	CString line, protocol;
	static clock_t startTime = clock();
	clock_t endTime;
	double elapsedTime;
	

	if (nIDEvent == ID_TIMER) {
		next_url();
		m_player.SetUrl(next_Url);
		KillTimer(ID_TIMER);
		KillTimer(ID_TIMEOUT);
		SetTimer(ID_TIMEOUT, 10000, NULL);
	}
	if (nIDEvent == ID_TIMEOUT) {
		if (u_index > 1) {
			CString total2;
			total2.Format("Total clips in URL: %d\n", u_index - 1);
			myFile.Write(total2, total2.GetLength());
			myFile.Flush();
		}
		next_url();
		m_player.SetUrl(next_Url);
		KillTimer(ID_TIMEOUT);
		SetTimer(ID_TIMEOUT, 10000, NULL);
	}
/*	
	if (timer_reset == 1 ) {
		startTime = clock();
		timer_reset = 0;
	}
	endTime = clock();
	elapsedTime = (double)(endTime - startTime) / CLOCKS_PER_SEC;
	
	//Frame rate
	fps = m_player.GetNetwork().GetFrameRate()/100.0;
	line.Format("%2.2f",fps);
	m_fps.SetWindowText(line);

	//buffering count
	bufp = m_player.GetNetwork().GetBufferingProgress();

	//bit rate
	brate = m_player.GetNetwork().GetBitRate();

	//bandwidth
	bw = m_player.GetNetwork().GetBandWidth();

	//max bandwidth
	maxbw = m_player.GetNetwork().GetMaxBandwidth();

	//encoded frame rate
	encodefr = m_player.GetNetwork().GetEncodedFrameRate();
	
	//Frame skipped
	frskipped = m_player.GetNetwork().GetFramesSkipped();
	
	//Received packets
	recpkt = m_player.GetNetwork().GetReceivedPackets();
	
	//Lost packets
	lostpkt = m_player.GetNetwork().GetLostPackets();
	
	//recovered packets
	recoverpkt = m_player.GetNetwork().GetRecoveredPackets();
	
	//Reception Qualisy
	quality = m_player.GetNetwork().GetReceptionQuality();

	//protocol
	protocol = m_player.GetNetwork().GetSourceProtocol();

	line.Format("%4.4f\t%3d\t%8d\t%8d\t%8d\t%2.2f\t%8d\t%3d\t%8d\t%8d\t%8d\t%8d\t%s\n", 
		elapsedTime, bufp, brate, bw, maxbw, fps, encodefr, frskipped, 
		recpkt, lostpkt, recoverpkt, quality, protocol);
	myFile.Write(line, line.GetLength());
*/
	CDialog::OnTimer(nIDEvent);
}

void CMediaTrackerDlg::CreateLog()
{
	CString line;
	CFileException fileException;
/*	CString strDirectory;
	CString file_name;
	CFileStatus status;

	GetCurrentDirectory( _MAX_PATH, strDirectory.GetBufferSetLength( _MAX_PATH ));
	strDirectory.ReleaseBuffer( );
	
	file_name = strDirectory + "\\data\\" + pszFileName;
	if( !CFile::GetStatus( "data", status ) ) {	
		MessageBox("A new folder \"data\" had been create under: \n\t" + strDirectory);
		CreateDirectory("data", NULL);
	}
*/

	if ( !myFile.Open( pszFileName, CFile::modeCreate | CFile::modeReadWrite ), &fileException ) {
		TRACE( "Can't open file %s, error = %u\n", pszFileName, fileException.m_cause );
	}
	line.Format("Time\tBuf_Progress\tBit_Rate\tBandWidth\tMax_BandW\tFrame_Rate\tRncode_Fr\tFr_Skipped\tReceived_Pkts\tLost_Pkts\tRecover_Pkts\tQuality\tProtocol\n");
//	myFile.Write(line, line.GetLength());
}

BEGIN_EVENTSINK_MAP(CMediaTrackerDlg, CDialog)
    //{{AFX_EVENTSINK_MAP(CMediaTrackerDlg)
	ON_EVENT(CMediaTrackerDlg, IDC_PLAYER, 5101 /* PlayStateChange */, OnPlayStateChangePlayer, VTS_I4)
	ON_EVENT(CMediaTrackerDlg, IDC_PLAYER, 5001 /* OpenStateChange */, OnOpenStateChangePlayer, VTS_I4)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

void CMediaTrackerDlg::OnPlayStateChangePlayer(long NewState) 
{

	switch(NewState){
	case 8:
		timer_reset = 1;
		if (shutdown_flag == 0) {
			shutdown_flag = 1;	
		}
		
		break;
	case 10:
		if (shutdown_flag == 1) {
			KillTimer(ID_TIMER);
			CShutDownDlg down;
			if (down.DoModal() == IDOK) {
				OnCancel();
			}			
		}
	//	m_player.GetControls().play();
		break;
	case 3:
		
		break;
  }

}



int CMediaTrackerDlg::CommandParser()
{
	
switch (__argc) {
	case 1:
		return 1;
	case 2:
		m_player.SetUrl(__argv[1]);
		break;
	case 3:
		m_player.SetUrl(__argv[1]);
		pszFileName.Format("%s", __argv[2]);
		break;
	default:
		AfxMessageBox ("Error Command Lines input!\nUse\"MediaTracker playlist.wpl logfile\"");
		return -1;
	}

//	SetTimer(ID_TIMER, 500, NULL);	
	return 1;
}

void CMediaTrackerDlg::OnOpenStateChangePlayer(long NewState) 
{
	CString line1, line2, line3, line4, line5;
	static CString FirstUrl, LastUrl;
	static int record = 0;
	long i, count;
	CString u, c;
	CString bar ("===============");

	switch(NewState) {
	case 13:
		KillTimer(ID_TIMEOUT);
		u = m_player.GetCurrentMedia().GetSourceURL();
		if (u == LastUrl || u == FirstUrl) {
			CString total;
			total.Format("Total clips in URL: %d\n", u_index - 1);
			myFile.Write(total, total.GetLength());
			myFile.Flush();
			SetTimer(ID_TIMER, 500, NULL);
			break;
		}
		line1 = m_player.GetCurrentMedia().GetName();
		line2 = m_player.GetCurrentMedia().GetSourceURL();
		line3.Format("Duration: %s (%4.2f secs)", m_player.GetCurrentMedia().GetDurationString(), m_player.GetCurrentMedia().GetDuration());
		line4.Format("Resulation: %d*%d", m_player.GetCurrentMedia().GetImageSourceWidth(), m_player.GetCurrentMedia().GetImageSourceHeight());
		count = m_player.GetCurrentMedia().GetAttributeCount();
		for (i =0; i < count; i++){ 
			line5 += m_player.GetCurrentMedia().getAttributeName(i);
			line5 += "\t";
			line5 += m_player.GetCurrentMedia().getItemInfo(m_player.GetCurrentMedia().getAttributeName(i));
			line5 += "\n";
		}
		line1 = line1 + "\n" + /*line2 + "\n" + line3 + "\t" + */line4 + "\n" + line5 + "\n";		
		
		if (u_index == 1) {
			FirstUrl = m_player.GetCurrentMedia().GetSourceURL();
			url_count++;
			c.Format("%d-%d",url_count, u_index);
			m_fps.SetWindowText(c);
			c.Format("%d", url_count);
			CString temp = bar + "\n" + "URL - " + c + ": " + next_Url +"\n\n";
			myFile.Write(temp, temp.GetLength());
		}
		else {
			c.Format("%d-%d",url_count, u_index);
			m_fps.SetWindowText(c);
		}

		myFile.Write(line1, line1.GetLength());
		myFile.Flush();
		LastUrl = m_player.GetCurrentMedia().GetSourceURL();

		if (m_player.GetControls().GetIsAvailable("Next") == 1 || m_player.GetControls().GetIsAvailable("next") == 1) {
			m_player.GetControls().next();
			u_index++;
			SetTimer(ID_TIMEOUT, 10000, NULL);
		}
		else {
			CString total2;
			total2.Format("Total clips in URL: %d\n", u_index);
			myFile.Write(total2, total2.GetLength());
			myFile.Flush();
			SetTimer(ID_TIMER, 500, NULL);
		}
		break;
	case 7:
	
		break;
	}
}

void CMediaTrackerDlg::OnAbout() 
{
	CAboutDlg dlgAbout;
	dlgAbout.DoModal();
	
}

void CMediaTrackerDlg::GetLogName(CString* logname)
{
	CString name;
	CTime theTime = CTime::GetCurrentTime();
	name = theTime.Format("%Y%m%d%H%M%S.dat");
	*logname = name;
	return;
}

void CMediaTrackerDlg::next_url()
{
	char *x = new char[1000];
	plFile.getline(x, 1000);
	next_Url.Format("%s", x);
	delete[] x;
	u_index = 1;
}